diff --git a/core/pldm/Makefile.inc b/core/pldm/Makefile.inc
index defcfde6..a067272b 100644
--- a/core/pldm/Makefile.inc
+++ b/core/pldm/Makefile.inc
@@ -9,11 +9,13 @@ CPPFLAGS += -I$(SRC)/pldm/ibm/libpldm/
 
 CFLAGS_$(PLDM_DIR)/pldm-platform-requests.o = -Wno-strict-prototypes
 CFLAGS_$(PLDM_DIR)/pldm-bios-requests.o = -Wno-strict-prototypes
+CFLAGS_$(PLDM_DIR)/pldm-watchdog.o = -Wno-strict-prototypes
 
 PLDM_OBJS = pldm-mctp.o pldm-responder.o pldm-requester.o
 PLDM_OBJS += pldm-base-requests.o pldm-platform-requests.o
 PLDM_OBJS += pldm-bios-requests.o pldm-fru-requests.o
 PLDM_OBJS += pldm-file-io-requests.o pldm-lid-files.o
+PLDM_OBJS += pldm-watchdog.o
 
 PLDM = $(PLDM_DIR)/built-in.a
 $(PLDM): $(PLDM_OBJS:%=$(PLDM_DIR)/%)
diff --git a/core/pldm/pldm-watchdog.c b/core/pldm/pldm-watchdog.c
new file mode 100644
index 00000000..11a5f187
--- /dev/null
+++ b/core/pldm/pldm-watchdog.c
@@ -0,0 +1,134 @@
+// SPDX-License-Identifier: Apache-2.0 OR GPL-2.0-or-later
+// Copyright 2022 IBM Corp.
+
+#define pr_fmt(fmt) "PLDM: " fmt
+
+#include <lock.h>
+#include <stdlib.h>
+#include <string.h>
+#include <opal.h>
+#include <timebase.h>
+#include <timer.h>
+#include <pldm/libpldm/platform.h>
+#include "pldm.h"
+
+#define DEFAULT_WATCHDOG_TIMEOUT_SEC (10 * 60) /* 10 min */
+
+/* Whether the watchdog timer is armed and Skiboot should be sending
+ * regular heartbeats.
+ */
+bool watchdog_armed;
+
+/* The period (in seconds) of the PLDM watchdog, as dictated by BMC */
+int watchdog_period_sec = DEFAULT_WATCHDOG_TIMEOUT_SEC;
+
+static struct lock sequence_lock;
+static uint8_t sequence_number;
+
+static void watchdog_reset_timer_complete(struct pldm_rx_data *rx,
+					  void *data __unused)
+{
+	struct pldm_platform_event_message_resp response;
+	size_t payload_len;
+	int rc;
+
+	if (rx == NULL) {
+		prlog(PR_ERR, "%s: Response not received\n", __func__);
+		return;
+	}
+
+	/* Decode the message */
+	payload_len = rx->msg_len - sizeof(struct pldm_msg_hdr);
+
+	rc = decode_platform_event_message_resp(
+			rx->msg,
+			payload_len,
+			&response.completion_code,
+			&response.platform_event_status);
+	if (rc != PLDM_SUCCESS || response.completion_code != PLDM_SUCCESS) {
+		prlog(PR_ERR, "Decode PlatformEventMessage Error, rc: %d, cc: %d, pes: %d\n",
+			       rc, response.completion_code,
+			       response.platform_event_status);
+	}
+}
+
+int pldm_watchdog_reset_timer(void)
+{
+	uint8_t heartbeat_elapsed_data[2];
+	uint32_t request_length;
+	size_t payload_len;
+	char *request_msg;
+	int rc;
+
+	struct pldm_platform_event_message_req event_message_req = {
+		.format_version = PLDM_PLATFORM_EVENT_MESSAGE_FORMAT_VERSION,
+		.tid = HOST_TID,
+		.event_class = PLDM_HEARTBEAT_TIMER_ELAPSED_EVENT,
+	};
+
+	/* watchdog is not armed, so no need to send the heartbeat */
+	if (!watchdog_armed) {
+		prlog(PR_ERR, "%s - PLDM watchdog is not armed, not sending the heartbeat\n",
+			      __func__);
+		return OPAL_PARAMETER;
+	}
+
+	prlog(PR_INFO, "%s - send the heartbeat to the BMC, sequence: %d, period: %d\n",
+		       __func__, sequence_number, watchdog_period_sec);
+
+	/* Send the event request */
+	heartbeat_elapsed_data[0] = PLDM_PLATFORM_EVENT_MESSAGE_FORMAT_VERSION;
+
+	/* We need to make sure that we send the BMC the correct
+	 * sequence number. To prevent possible race conditions for the
+	 * sequence number, lock it while we're incrementing and
+	 * sending it down.
+	 */
+	lock(&sequence_lock);
+	heartbeat_elapsed_data[1] = sequence_number++;
+
+	payload_len = PLDM_PLATFORM_EVENT_MESSAGE_MIN_REQ_BYTES + sizeof(heartbeat_elapsed_data);
+
+	request_length = sizeof(struct pldm_msg_hdr) +
+			 sizeof(struct pldm_platform_event_message_req) +
+			 sizeof(heartbeat_elapsed_data);
+	request_msg = zalloc(request_length);
+
+	/* Encode the platform event message request */
+	rc = encode_platform_event_message_req(
+			DEFAULT_INSTANCE_ID,
+			event_message_req.format_version,
+			event_message_req.tid,
+			event_message_req.event_class,
+			heartbeat_elapsed_data,
+			sizeof(heartbeat_elapsed_data),
+			(struct pldm_msg *)request_msg,
+			payload_len);
+	if (rc != PLDM_SUCCESS) {
+		prlog(PR_ERR, "Encode PlatformEventMessage Error, rc: %d\n", rc);
+		free(request_msg);
+		sequence_number--;
+		return OPAL_PARAMETER;
+	}
+	unlock(&sequence_lock);
+
+	/* Send and get the response message bytes */
+	rc = pldm_requester_queue(request_msg, request_length - 1,
+				  watchdog_reset_timer_complete, NULL);
+	if (rc) {
+		prlog(PR_ERR, "Communication Error, req: PlatformEventMessage, rc: %d\n", rc);
+		free(request_msg);
+		sequence_number--;
+		return rc;
+	}
+	free(request_msg);
+
+	return OPAL_SUCCESS;
+}
+
+int pldm_watchdog_init(void)
+{
+	init_lock(&sequence_lock);
+
+	return pldm_watchdog_reset_timer();
+}
diff --git a/core/pldm/pldm.h b/core/pldm/pldm.h
index 35b0dd66..5b080644 100644
--- a/core/pldm/pldm.h
+++ b/core/pldm/pldm.h
@@ -41,6 +41,7 @@ struct pldm_rx_data {
 };
 
 int pldm_mctp_message_tx(uint8_t dest_id, uint8_t *buf, int len);
+int pldm_watchdog_reset_timer(void);
 
 /* Responder support */
 int pldm_responder_handle_request(struct pldm_rx_data *rx);
diff --git a/include/pldm.h b/include/pldm.h
index 9abb82ac..231b517f 100644
--- a/include/pldm.h
+++ b/include/pldm.h
@@ -42,4 +42,9 @@ int pldm_lid_files_init(struct blocklevel_device **bl);
  */
 bool pldm_lid_files_exit(struct blocklevel_device *bl);
 
+/**
+ * Initialize and reset the watchdog
+ */
+int pldm_watchdog_init(void);
+
 #endif /* __PLDM_H__ */